/*
    InfoIO.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "InfoIO.h"

InfoIO* InfoIO::getInfoIO (DlHandler* handler, const string& name)
{
  assert (handler != NULL);

  string infoIOName;
  infoIOName = "infoIO";
  infoIOName += name;
  InfoIO* info=static_cast<InfoIO*> (handler->sym (infoIOName));
  
  return info;
}

IO* InfoIO::createIO (DlHandler* dlHandler, const string& name, 
		      State* state, WidiController* widiController,
		      Option* option)
{
  assert (dlHandler != NULL);
  assert (state != NULL);
  assert (widiController != NULL);
  assert (option != NULL);
  
  InfoIO* infoio=InfoIO::getInfoIO (dlHandler, name);
  if (infoio != NULL)
    return infoio->newIO (state, widiController, option);
  
  return NULL;
}


