/*
    PH0.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <fstream>

#include "PH0.h"

void PH0::load (const string& fileName)
{
  ifstream ph0;
#if 0
  try
    {
      ph0.open (fileName.c_str ());
    }
  catch (ifstream::failure)
    {
      throw FileIsNotFound ();
    }
#else
  ph0.open (fileName.c_str ());
  if (!ph0)
    throw FileIsNotFound ();
#endif

  ph0.seekg (0, ios::end);
  ulong size=ph0.tellg ();
  ph0.seekg (0, ios::beg);
  if (size != 96000 && size != 128000)
    {
      ph0.close ();
      throw FileIsNotPh0Format ();
    }
  b= new uchar [640*400/8];
  ph0.read (b, 640*400/8);
  r= new uchar [640*400/8];
  ph0.read (r, 640*400/8);
  g= new uchar [640*400/8];
  ph0.read (g, 640*400/8);
  if (size == 96000)
    e = NULL;
  else
    {
      e= new uchar [640*400/8];
      ph0.read (e, 640*400/8);
    }

  ph0.close ();
}


