/*
    PH0.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef PH0_H
#define PH0_H

#include <string>

#include "util/mytype.h"

using namespace std;

class PH0
{
private:
  uchar* b;
  uchar* r;
  uchar* g;
  uchar* e;
public:
  PH0 (): b (NULL), r (NULL), g (NULL), e (NULL) {};
  ~PH0 ()
    {
      delete[] b;
      delete[] r;
      delete[] g;
      delete[] e;
    };
  class PError {};
  class FileIsNotFound:public PError {};
  class FileIsNotPh0Format:public PError {};
  void load (const string& fileName);
  const uchar* getR () const {return r;};
  const uchar* getG () const {return g;};
  const uchar* getB () const {return b;};
  const uchar* getE () const {return e;};
};

#endif PH0_H
