/*
    SherryArea.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef SherryArea_H
#define SherryArea_H

#include <algorithm>
#include <functional>

using namespace std;

class SherryArea
{
private:
  const int left;
  const int top;
  const uint width;
  const uint height;
public:
  //(x1, y1)-(x2, y2)$B$GI=$5$l$kNN0h$r(B(left, top, width, height)$B$GI=8=$7D>$9!#(B
  SherryArea (uint16 x1, uint16 y1, uint16 x2, uint16 y2):
    left (min (x1, x2)),
    top (min (y1, y2)),
    width (max (x1, x2)-min (x1, x2)+1),
    height (max (y1, y2)-min (y1, y2)+1)
    {};
  ~SherryArea () {};
  
  int getLeft () const {return left;};
  int getTop () const {return top;};
  uint getWidth () const {return width;};
  uint getHeight () const {return height;};
};
#endif // SherryArea_H
