/*
    getResouce.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "getResource.h"

char* getResource (XrmDatabase privateRdb, XrmDatabase displayRdb,
		   const string& className_, const string& classResource_,
		   const string& name_, const string& resourceName_)
{
  const string fullClassName = className_ + "." + classResource_;
  const string fullName = name_ + "." + resourceName_;
  char* retType;
  XrmValue retValue;
  int result = (displayRdb !=NULL &&
		XrmGetResource (displayRdb,
				fullClassName.c_str (), fullName.c_str (),
				&retType, &retValue));
  if (!result)
    result = XrmGetResource (privateRdb,
			     fullClassName.c_str (), fullName.c_str (),
			     &retType, &retValue);
  if (!result)
    return NULL;
  return retValue.addr;
}

