/*
    DotData.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef DotData_H
#define DotData_H

#include "MIDI.h"


//display page$B$N(B
//$B1U>=I=<($NItJ,$r3P$($F$*$/%/%i%9(B
class DotData
{
public:
  static const int MAX_LINES = 16;
  static const int MAX_COLS = MIDI::MAX_CHANNEL;

  static const int ROLAND_DOT_DATA_SIZE = 64;
private:
  bool __isOn[MAX_LINES][MAX_COLS];
  //          $B=D(B(y)      $B2#(B(x)
  //     x->
  //   y(0, 0)  (1, 0)     (15, 0)
  //   |(0, 1)         
  //   v        (x, y) 
  //                   
  //    (0,15)             (15, 15)
  //

  
  inline void setRolandLCD (const uchar rolandDotData[ROLAND_DOT_DATA_SIZE],
			     bool lcd[MAX_LINES][MAX_COLS],
			     const int dataOffset, const int columnOffset);
public:
  DotData ();
  ~DotData ();
  
  bool isOn (int y, int x) const {return __isOn[y][x];};
  
  void reset ();//$BJQ?t$r=i4|2=$9$k!#(B

  //rolland$B$N>l9g(B
  void setRolandDotData (const uchar rolandDotData[ROLAND_DOT_DATA_SIZE]);

  //yamaha$B$N>l9g(B
  //void setYamahaDotData ();
};
#endif// DotData_H
