#ifndef InstrumentName_H
#define InstrumentName_H

#include <string>

#include "SequencerStatus.h"

using namespace std;

class InstrumentName
{
public:
  static const int MAX_ENTRY = 128;
  
private:

  
  char* inst_sc88_pro[MAX_ENTRY][MAX_ENTRY];
  char* inst_sc88_88[MAX_ENTRY][MAX_ENTRY];
  char* inst_sc88_55[MAX_ENTRY][MAX_ENTRY];
  char* drum_sc88_pro[MAX_ENTRY];
  char* drum_sc88_88[MAX_ENTRY];
  char* drum_sc88_55[MAX_ENTRY];
  char* efx_sc88_pro[MAX_ENTRY][MAX_ENTRY];

  char* inst_xg[MAX_ENTRY][MAX_ENTRY];
  char* inst_mu100[MAX_ENTRY][MAX_ENTRY];
  char* sfx_xg[MAX_ENTRY];
  char* drum_sfx_xg[MAX_ENTRY];
  char* drum_xg[MAX_ENTRY];

  char* inst_korg[MAX_ENTRY][MAX_ENTRY];
  
public:
  InstrumentName ();
  ~InstrumentName () {};
  
  ////////////////////////////////////////////////////////////
  const char* getInstrumentName (uchar program, uchar bankLSB, uchar bankMSB,
				 SequencerStatus::DeviceMode deviceMode,
				 uchar useForRythmPart) const;
  const char* getDefaultInstrumentName () const;
  const char* getDefaultDrumName () const;

  //////////////////////////////////////////////////////////////////////
  void readConfigFile (const string& fileName);
  class ConfigFileError
  {
  private:
    const string errorDescription;
  public:
    ConfigFileError (string& errorDescription__):
      errorDescription (errorDescription__)
      {};
    virtual ~ConfigFileError () {};
    const string& getErrorDescription () const {return errorDescription;};
    void raise () {throw *this;};
  };
};
#endif InstrumentName_H
