/*
    SequencerBaseImple.h
  
    Copyright (C) 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef SeqeuncerBaseImple_H
#define SeqeuncerBaseImple_H

#include "Sequencer.h"

//SequencerμδäȤʤΤ륯饹
//վ֤פʬ롣
class SequencerBaseImple:public Sequencer
{
public:
  SequencerBaseImple (State* globalState, Option* midiOption);//constructor
  virtual ~SequencerBaseImple ();//destructor
  
protected:
  //satusι
  //sequencerξ֤פ˻Ȥ᥽å
  void traceDumpBuf ()
    {
      for (int port = 0; port < MIDI::MAX_PORT; port++)
	{
	  for (int channel = 0; channel < MIDI::MAX_CHANNEL; channel++)
	    {
	      if (cacheState.part[port][channel].getMaxVelocity () > 0)
		cacheState.part[port][channel].setLastMaxVelocity
		  (cacheState.part[port][channel].getMaxVelocity ());
	      cacheState.part[port][channel].setMaxVelocity (0);
	    }
	}
    };
  
  
  //port=0 port_a
  //port=1 port_b
  virtual void tracePortChange (int port);
  
  void traceNoteOff (int port, uchar channel, uchar note, uchar velocity);
  void traceNoteOn (int port, uchar channel, uchar note, uchar velocity);
  void tracePolyphonicKeyPressure (int port, uchar channel,
				   uchar note, uchar keyPressure);
  void traceControlChange (int port, uchar channel,
			   uchar control, uchar value);
  void traceProgramChange (int port, uchar channel, uchar  program);
  void traceChannelPressure (int port, uchar channel, uchar pressure);
  void tracePitchBendChange (int port, uchar channel, uchar lsb, uchar msb);


  void traceExclusive (const uchar* udata, uint32 size,
		       int port = -1, int channel = -1);
  
  //exclusive
  void traceUniversalRealtimeExclusive (const uchar* udata, uint32 size);
  void traceUniversalNonrealtimeExclusive (const uchar* udata, uint32 size);
  void traceRolandExclusive (const uchar* udata, uint32 size);
     void traceRolandDisplayData (const uchar* udata, uint32 size);
        void traceRolandDisplayedLetter (const uchar* udata, uint32 size);
        void traceRolandDisplayedDotData (const uchar* udata, uint32 size);
        void traceRolandDisplayPage (const uchar* udata, uint32 size);
     void traceRolandSystemParameter (const uchar* udata, uint32 size);
  void traceYamahaExclusive (const uchar* udata, uint32 size);
};
#endif// SeqeuncerBaseImple_H
