/*
    SongFactory.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef SongFactory_H
#define SongFactory_H

#include <list>

#include "InfoSong.h"
#include "util/DlHandler.h"
#include "util/Mutex.h"

using namespace std;

class SongFactory
{
private:
  static Mutex lock;
  class MonitorLock
  {
  public:
    MonitorLock () {SongFactory::lock.lock ();};
    ~MonitorLock () {SongFactory::lock.unlock ();};
  };
  friend MonitorLock;


  SongFactory ();
  list<InfoSong*> infoSongList;
  list<DlHandler*> dlHandlerList;
  static SongFactory songFactory;
  Song* __newSong  (const string& fileName, State* state,
		    SongCommand* songCommand, MainIO& userIO,
		    Option* option__);
  void __addSongModule (const string& songModuleName, Option* option__);

  static SongFactory& instance ()
    {return songFactory;};
public:
  ~SongFactory ();

  static void addSongModule (const string& songModuleName, Option* option__)
    {instance ().__addSongModule (songModuleName, option__);};
  ////////////////////////////////////////////////////////////factory mathod
  static Song* newSong (const string& fileName, State* state,
			SongCommand* songCommand, MainIO& userIO,
			Option* option__)
    {return instance ().__newSong (fileName,
				   state, songCommand, userIO, option__);};
};

#endif // SongFactory_H
