/*
    SongFileList.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "SongFileList.h"
#include "IO/MainIONull.h"
#include "Song/SongFactory.h"
#include "util/Random.h"

void SongFileList::searchAppend (const string& filename)
{
  DEBUG_MESSAGE ("SongFileList::append called");
  SongFileItem songFileItem (filename);
  if (songFileItem.search ())
    {//fileäƱղǽեä
      DEBUG_MESSAGE ("SongFileList::append appending.");
      push_back (songFileItem);
    }
  DEBUG_MESSAGE ("SongFileList::append done.");
}

void SongFileList::append (const string& filename)
{
  DEBUG_MESSAGE ("SongFileList::append called");
  SongFileItem songFileItem (filename);
  push_back (songFileItem);
  DEBUG_MESSAGE ("SongFileList::append done.");
}


SongFileList::SongItem SongFileList::getRidOf (uint i)
{
  if (i >= size ())
    return end ();
  
  iterator j = begin ();
  for (uint k = 0; k < i; i++, j++)
    /*do nothing*/;
  
  return erase (j);
}


SongFileList::SongItem SongFileList::getRidOf (const string& filename)
{
  for (iterator i = begin (); i != end (); i++)
    {
      if ((*i).getFileName () == filename)
	return erase (i);
    }

  return end ();
}

SongFileList::SongItem SongFileList::getRidOf (const SongFileItem& songFileItem)
{
  for (iterator i = begin (); i != end (); i++)
    {
      if (*i == songFileItem)
	return erase (i);
    }

  return end ();
}

void SongFileList::randomShuffle ()
{
  Random random;
  uint j = 1;//1ʤΤ% jͤ[0,j)ʤΤ
  for (iterator i = begin (); i != end (); i++, j++)
    {
      iter_swap (i, get (random () % j));
    }
  
  //list is not random accessible
  //so, can not use random_shuffle
  //random_shuffle (begin (), end ());
}
