/*
    TimerSignal.cc
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "TimerSignal.h"

TimerSignal::~TimerSignal ()
{
  for (Connections::reverse_iterator i = connections.rbegin ();
       i != connections.rend ();
       i++)
    delete (*i).second;
}
  
void TimerSignal::connect (Tag tag, TimerConnection* timerConnection__)
{
  assert (timerConnection__ != NULL);
  connections.push_back (pair<Tag, TimerConnection*> (tag, timerConnection__));
}

bool TimerSignal::disconnect (Tag tag)
{
  for (Connections::iterator i = connections.begin ();
       i != connections.end ();
       i++)
    {
      if ((*i).first == tag)
	{
	  delete (*i).second;
	  connections.erase (i);
	  return true;
	}
    }

  return false;
}


void TimerSignal::operator () ()
{
  for (Connections::iterator i = connections.begin ();
       i != connections.end ();
       i++)
    (*i).second->call ();
}

