/*
    calcTime.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef calcTime_H
#define calcTime_H

#include "Song/SongStatus.h"

struct TimeInfo
{
  uint minute;
  uint second;
  uint milisecond;
};

//$B:F@8;~4V$rF@$k!#(B
TimeInfo calcTime (double logicalTicks)
{
  const int rate = SongStatus::SONG_CTRL_RATE;
  TimeInfo timeInfo;
  timeInfo.minute = static_cast<uint> (logicalTicks/rate/60);
  logicalTicks -= timeInfo.minute*rate*60;
  timeInfo.second = static_cast<uint> (logicalTicks/rate);
  logicalTicks -= timeInfo.second*rate;
  timeInfo.milisecond = static_cast<uint> (logicalTicks*1000/rate);
  return timeInfo;
};
#endif // calcTime_H
