/*
    compareTime.h
  
    Copyright (C) 1998, 1999 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef compareTime_H
#define compareTime_H

#include <ctime>
#include <sys/time.h>

//first,second$B$NBg>.4X78$rHf$Y$k!#(B
inline int compareTime (const timespec& first, const timespec& second)
{
  if (first.tv_sec > second.tv_sec)
    return 1;
  else if (first.tv_sec < second.tv_sec)
    return -1;
  else if (first.tv_nsec > second.tv_nsec)
    return 1;
  else if (first.tv_nsec < second.tv_nsec)
    return -1;
      
  return 0;
};
  
inline int compareTime (const timespec& first, const timeval& second)
{
  if (first.tv_sec > second.tv_sec)
    return 1;
  else if (first.tv_sec < second.tv_sec)
    return -1;
  else if (first.tv_nsec > second.tv_usec*1000)
    return 1;
  else if (first.tv_nsec < second.tv_usec*1000)
    return -1;
      
  return 0;
};

//first,second$B$NBg>.$rHf$Y(B
//first>second$B$J$i$P$=$N:9$N;~4V$r(Bresult$B$KF~$l$k(B
inline int diffTime (const timespec& first, const timeval& second,
		     timespec& result)
{
  result.tv_sec = first.tv_sec - second.tv_sec;
  if (result.tv_sec > 0)
    {
      result.tv_nsec = first.tv_nsec-second.tv_usec*1000;
      if (result.tv_nsec < 0)
	{//$B7+$j2<$,$j(B
	  result.tv_sec--;
	  result.tv_nsec += 1000000000;
	}
      else
	{
	  result.tv_sec = first.tv_sec-second.tv_sec;
	}
      
      return 1;
    }
  else if (result.tv_sec < 0)
    return -1;
  else
    {//result.tv_sec == 0
      result.tv_nsec = first.tv_nsec - second.tv_usec*1000;
      if (result.tv_nsec > 0)
	return 1;
      else if (result.tv_nsec < 0)
	return -1;
    }
      
  return 0;
};

#endif compareTime_H
